"""
ALTER TABLE:
- time_start, time_stop
- pridat id?
- zrusit orig. pkey?



CREATE VIEW trest_current AS SELECT gid, num, txt FROM trest WHERE time_stop IS NULL


CREATE OR REPLACE FUNCTION trest_at_time(timestamp)
RETURNS SETOF trest_current AS
$$
SELECT gid,num,txt FROM trest WHERE
  ( SELECT CASE WHEN time_stop IS NULL THEN (time_start <= $1) ELSE (time_start <= $1 AND time_stop > $1) END );
$$
LANGUAGE 'SQL';


CREATE RULE trest_del AS ON DELETE TO trest
DO INSTEAD UPDATE trest SET time_stop = current_timestamp WHERE gid = OLD.gid AND time_stop IS NULL;


CREATE OR REPLACE FUNCTION trest_update()
RETURNS TRIGGER AS
$$
BEGIN
  IF OLD.time_stop IS NOT NULL THEN
    RETURN NULL;
  END IF;
  IF NEW.time_stop IS NULL THEN
    INSERT INTO trest VALUES (OLD.gid, OLD.num, OLD.txt, OLD.time_start, current_timestamp);
    NEW.time_start = current_timestamp;
  END IF;
  RETURN NEW;
END;
$$
LANGUAGE 'plpgsql';

CREATE TRIGGER trest_update BEFORE UPDATE ON trest
FOR EACH ROW EXECUTE PROCEDURE trest_update();


insert: 
- open (allows setting start, stop time)
- aggresive (start -> current_timestamp, stop -> null)
CREATE OR REPLACE FUNCTION trest_insert
RETURNS TRIGGER AS
$$
  NEW.time_start := now();
  NEW.time_stop := null;
  RETURN NEW;
$$
LANGUAGE 'sql';

???? ... pise ze sql nemoze vracat trigger ... ???
CREATE OR REPLACE FUNCTION hist.trest_insert()
RETURNS trigger AS
$$
BEGIN
  NEW.time_start = now();
  NEW.time_stop = null;
  RETURN NEW;
END;
$$
LANGUAGE 'plpgsql';
???

CREATE TRIGGER trest_insert BEFORE INSERT ON trest
FOR EACH ROW EXECUTE PROCEDURE trest_insert();


update aktualneho view:

CREATE OR REPLACE RULE "_DELETE" AS ON DELETE TO trest_current DO INSTEAD
  DELETE FROM trest WHERE gid = old.gid;
CREATE OR REPLACE RULE "_INSERT" AS ON INSERT TO trest_current DO INSTEAD
  INSERT INTO trest (gid, num, txt) VALUES (new.gid, new.num, new.txt);
CREATE OR REPLACE RULE "_UPDATE" AS ON UPDATE TO trest_current DO INSTEAD
  UPDATE trest SET gid = new.gid, num = new.num, txt = new.txt WHERE gid = new.gid;



TODO:
- indexy

testy:
SELECT * FROM hist.trest_at_time(now()::timestamp)

now() == current_timestamp  (... maju typ timestamptz)


--------
insert into hist.hejhou (gid, textik, numero, geom) values (1, 'heh', 1, geometryfromtext('LINESTRING(1 1, 2 2)')); commit;
update hist.hejhou set numero=100 where gid=1;commit;
"""
