#-----------------------------------------------------------
# 
# Table Manager
# Copyright (C) 2008-2009 Borys Jurgiel
#
#-----------------------------------------------------------
# 
# licensed under the terms of GNU GPL 2
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
# 
#---------------------------------------------------------------------

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *

import resources_rc
import tableManager_gui

class tableManager:

 def __init__(self, iface):
  self.iface = iface


 def initGui(self):
  # create action 
  self.action = QAction(QIcon(':/plugins/tableManager/icons/tableManagerIcon.png'), 'Table manager', self.iface.mainWindow())
  self.action.setWhatsThis('Manages attribute table structure')
  QObject.connect(self.action, SIGNAL('activated()'), self.run)
  # add toolbar button and menu item
  self.iface.addToolBarIcon(self.action)
  self.iface.addPluginToMenu('&Table', self.action)


 def unload(self):
  # remove the plugin menu item and icon
  self.iface.removePluginMenu('&Table',self.action)
  self.iface.removeToolBarIcon(self.action)


 def run(self):
  # create and show a configuration dialog or something similar
  layer = self.iface.activeLayer()
  if layer == None or layer.type() != layer.VectorLayer:
    QMessageBox.warning(self.iface.mainWindow(), 'Table manager', 'Please select a vector layer')
  elif layer.isEditable():
    QMessageBox.warning(self.iface.mainWindow(), 'Table manager', 'The selected layer is currently in editing mode.\nPlease exit this mode before managing the table.')
  else:
    dialoga = tableManager_gui.TableManager(self.iface)
    dialoga.exec_()
